#! /usr/bin/env python
VERSION = '2.9.3'

if __name__ == '__main__':
	print 'QTorrent starting up.. Please be patient as this might some time..'
	import gettext
	gettext.install('bittorrent', 'locale')
	
	# Hack around stupid problems with global variables and namespace
	import pyqtorrent3, sys
	sys.path = pyqtorrent3.__path__ + sys.path
	pyqtorrent3.__path__ = []
	
	# Separate options from torrents
	import getopt
	try:
		opts, torrents = getopt.getopt(sys.argv[1:], "n", ["nogui"])
	except getopt.GetoptError:
		print "failed parsing commandline"
		sys.exit(2)
	
	nogui = False
	for o, a in opts:
		if o in ('-n', '--nogui'):
			nogui = True
	
	# Import the stuff we need
	from pyqtorrent3 import CONTROLSOCK, Config, run
	
	# Try to connect to an already running qtorrent3
	import socket
	sock = socket.socket(socket.AF_UNIX, socket.SOCK_STREAM)
	try:
		sock.connect(CONTROLSOCK)
		sock.close()
		for i in torrents:
			sock = socket.socket(socket.AF_UNIX, socket.SOCK_STREAM)
			sock.connect(CONTROLSOCK)
			sock.send(i + "\n")
			sock.close()
		sys.exit(0)
	except socket.error:
		pass
	
	# Load configuration
	config = Config()
	
	# Interfaces sanity checks
	if nogui and (not config['enable_web_interface'] or config['web_interface_password'] == ''):
		print 'No web interface password specified and gui disabled, nothing to do'
		sys.exit(0)
	elif config['enable_web_interface'] and not config['web_interface_password']:
		print 'Warning: no web interface password specified, disabling web interface'
	
	# Import psyco and enable profiling mode
	try:
		import psyco
		psyco.profile()
	except ImportError:
		print 'Note: Psyco not detected, take a peek here: http://psyco.sf.net/'
	
	# Now actually start qtorrent3
	run(VERSION, torrents, config, nogui)
	
	# Evil haxorism, slaughter lingering threads
	import threading, time
	if hasattr(threading.currentThread(), '_Thread__stop') and threading.activeCount() > 1:
		print 'Giving lingering threads 5 seconds to self-terminate'
		time.sleep(5)
		for t in threading.enumerate():
			if t != threading.currentThread() and hasattr(t, '_Thread__stop'):
				t._Thread__stop()
